Package: UNDO
Type: Package
Title: Unsupervised Deconvolution of Tumor-Stromal Mixed Expressions
Version: 1.53.0
Date: 2014-07-17
Author: Niya Wang <wangny@vt.edu>
Maintainer: Niya Wang <wangny@vt.edu>
Depends: R (>= 2.15.2), methods, BiocGenerics, Biobase
Imports: MASS, boot, nnls, stats, utils
biocViews: Software
Description: UNDO is an R package for unsupervised deconvolution of tumor and stromal mixed expression data. It detects marker genes and deconvolutes the mixing expression data without any prior knowledge.
License: GPL-2
git_url: https://git.bioconductor.org/packages/UNDO
git_branch: devel
git_last_commit: a43bf55
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-10-30
NeedsCompilation: no
Packaged: 2025-10-30 23:32:22 UTC; biocbuild

two_source_deconv <-
function(ExpressionData,lowper=0.4,highper=0.1,epsilon1=0.01,epsilon2=0.01,
                              A=NULL,S1=NULL,S2=NULL,return=0){
  
  ## check the input
  if (lowper<0||lowper>1||highper<0||highper>1){
    stop("ERROR: the gene removing percentage should be between 0 and 1.")
  }
  
  if (lowper+highper>1) stop('ERROR: the sum of lowper and highper should be smaller than 1.')
  
  if (epsilon1<0||epsilon2<0) stop('ERROR: the eps1/eps2 shoule be positive.')
  
  if (return!=0&&return!=1) stop('ERROR: return shoule be 0 or 1.')
  
  
  if (class(ExpressionData)=="matrix"){
    X <- ExpressionData
  } else if (class(ExpressionData)=="ExpressionSet"){
    X <- exprs(ExpressionData)
  } else {
    stop("ERROR: Please input expression data matrix or ExpressionSet data.")
  }
  
  
  ## select marker genes
  X <- unlist(gene_expression_input(X))
  markergene <- marker_gene_selection(X,lowper,highper,epsilon1,epsilon2)
  
  a1 <- unlist(markergene[[1]])
  a2 <- unlist(markergene[[2]])
  dimenMatrix <- unlist(markergene[[5]])
  
  deconvresult <- mixing_matrix_computation(X,a1,a2,dimenMatrix)
  Aest <- unlist(deconvresult[[1]])
  Sest <- unlist(deconvresult[[2]])
  
  
  ## check whether the input A is valid
  if(!is.null(A)) {
    if(dim(A)[1]!=dim(Aest)[1]||dim(A)[2]!=dim(Aest)[2]){
      warning('The size of input mixing matrix is different from estimated mixing matrix.')
      E1 <- NULL      
    }
    
    if(dim(A)[1]==dim(Aest)[1]&&dim(A)[2]==dim(Aest)[2]) {
      E1<- min(calc_E1(A,Aest),calc_E1(A,Aest[c(2,1),]))
    } else {
      E1<-NULL
    }
  } else E1 <- NULL
  
  
  ## calculate the correlation between estimated and measured expression
  if(!is.null(S1)){
    S_corr1 <- max(corr(cbind(S1,Sest[,1])),corr(cbind(S1,Sest[,2])))
  } else {
    S_corr1 <-NULL
  }
  
  if(!is.null(S2)){
    S_corr2 <- max(corr(cbind(S2,Sest[,1])),corr(cbind(S2,Sest[,2])))
  } else {
    S_corr2 <- NULL
  }
  
  ## output
  if (return==1) list(Estimated_Mixing_Matrix=Aest,E1=E1,S1_correlation=S_corr1,
                      S2_correlation=S_corr2,Sest)
  else list(Estimated_Mixing_Matrix=Aest,E1=E1,S1_correlation=S_corr1,S2_correlation=S_corr2)
  
}

calc_E1 <-
function(A,Aest){
  
  P <- ginv(Aest)%*%A
  
  m <- dim(P)[1]
  n <- dim(P)[2]
  
  if (m!=n) {
    stop('ERROR: column number should be equal to row number')
    return
  }
  
  E11 <- 0
  
  for (i in 1:m){
    max_pi <- -1000
    for (k in 1:m){
      if (abs(P[i,k])>max_pi){
        max_pi <- abs(P[i,k])
      }
    }
    sum1 <- 0
    for (j in 1:m){
      sum1 <- sum1+abs(P[i,j])/max_pi
    }
    E11 <- E11+(sum1-1)
  }
  
  E12 <- 0
  
  for (j in 1:m){
    max_pj <- -1000
    for (k in 1:m){
      if (abs(P[k,j])>max_pj){
        max_pj <- abs(P[k,j])
      }
    }
    sum2 <- 0
    for (i in 1:m){
      sum2 <- sum2+abs(P[i,j])/max_pj
    }
    E12 <- E12+(sum2-1)
  }
  E1 <- E11+E12 
  E1
  
}

dimension_reduction <-
function(X) {
    ##eigenvalue decomposition is used to reduce dimension
    
    X <- t(X)
    Xmean <- rowMeans(X)
    Xmeanrm <- X-Xmean  
    r <- eigen(Xmeanrm%*%t(Xmeanrm))
    dimenMatrix <- t(r$vectors[,1:2])
    Xt <- dimenMatrix%*%X
    X <- t(Xt)
    
    dimenreduc <- list(X,dimenMatrix)
    dimenreduc
  }

### R code from vignette source 'UNDO-vignette.Rnw'

###################################################
### code chunk number 1: packageLoad
###################################################
library(UNDO)
#load tumor stroma mixing tissue samples
data(NumericalMixMCF7HS27)
X <- NumericalMixMCF7HS27
#load mixing matrix for comparison
data(NumericalMixingMatrix)
A <- NumericalMixingMatrix


###################################################
### code chunk number 2: mixing matrix
###################################################
A


###################################################
### code chunk number 3: Deconvolution
###################################################
#load pure tumor stroma expressions 
data(PureMCF7HS27)
S <- exprs(PureMCF7HS27)

two_source_deconv(X,lowper=0.4,highper=0.1,epsilon1=0.01,
epsilon2=0.01,A,S[,1],S[,2],return=0)
											


###################################################
### code chunk number 4: Scatterplot
###################################################
# compute the estimated pure source expressions
result <- two_source_deconv(X,lowper=0.4,highper=0.1,epsilon1=0.01,
epsilon2=0.01,A,S[,1],S[,2],return=1)
Sest <- result[[5]]

#draw the scatter plots between pure and estimated expressions of 
#MCF7 and HS27
plot(S[,1],Sest[,1],main="MCF7" ,xlab="Estimated expression", 
ylab="Measured expression", xlim=c(0,15000), ylim=c(0,15000),
pch=1, col="turquoise", cex=0.5)


###################################################
### code chunk number 5: Scatterplot2
###################################################
plot(S[,2],Sest[,2],main="HS27" ,xlab="Estimated expression", 
ylab="Measured expression", xlim=c(0,15000), ylim=c(0,15000),
pch=1, col="turquoise", cex=0.5)

marker_gene_selection <-
function(X,lowper,highper,epsilon1,epsilon2) {
   
  data_size <- dim(X)[1]
  
  ## If X contains more than 2 samples,  the dimension reduction funcion is called.
  if(dim(X)[2]>2) {
    dimenreduc <- dimension_reduction(X)
    X <- unlist(dimenreduc[[1]])
    dimenMatrix <- unlist(dimenreduc[[2]])
    
  } else dimenMatrix <- NULL
  
  
  sigNorm <- matrix(0,1,data_size)
  for (i in 1:data_size) {
    sigNorm[i] <- norm(matrix(X[i,]),"F") 
  }
  
  sigOrder <- sort(sigNorm,index.return=TRUE)
  Xfilter <- X[sigOrder$ix[(lowper*data_size+1):(data_size-highper*data_size)],]
  Xfnorm <- sigNorm[sigOrder$ix[(lowper*data_size+1):(data_size-highper*data_size)]]
  
  k <- Xfilter[,2]/Xfilter[,1]
  eps1 <- epsilon1
  eps2 <- epsilon2
  
  MG1 <- which((k<=min(k)+abs(eps2*min(k)))&k>=min(k))
  MG2 <- which((k>=max(k)-abs(eps1*max(k)))&k<=max(k))

  
  ## handle the situation that one or two samples are pure
  if (max(k)==Inf) {
    a1 <- c(1,0)
  } else {
    
    if (length(MG1)==1) {
      a1 <- Xfilter[MG1,]/Xfnorm[MG1]
    } else {
      a1 <- colMeans(Xfilter[MG1,]/Xfnorm[MG1])
    }
    
  }
  
  if (min(k)==0){
    a2 <- c(0,1)
  } else {
    if (length(MG2)==1) {
      a2 <- Xfilter[MG2,]/Xfnorm[MG2]
    } else {
      a2 <- colMeans(Xfilter[MG2,]/Xfnorm[MG2])
    }
  }
  
  
  markergene <- list(a1,a2,MG1,MG2,dimenMatrix)
  markergene
    
}

mixing_matrix_computation <-
function(X,a1,a2,dimenMatrix){

  
  Aest <- cbind(a1,a2)
  
  
  if(!is.null(dimenMatrix)){
    Atrans <- ginv(t(dimenMatrix)%*%dimenMatrix)%*%t(dimenMatrix)%*%Aest
    scale <- ginv(Atrans)%*%matrix(1,dim(X)[2],1)
    scale <- as.vector(scale)
    Aest <- Atrans%*%diag(scale)
  } else {
    
    scale <- ginv(Aest)%*%matrix(1,2,1)
    scale <- as.vector(scale)
    Aest <- Aest%*%diag(scale)
  }
  
  Aest <- Aest/matrix(rep(rowSums(Aest),2),nrow(Aest),2)

  Sest <- matrix(0,ncol=dim(Aest)[2],nrow=dim(X)[1])
  for (i in 1:nrow(X)){
    Sest[i,] <- coef(nnls(Aest,X[i,]))
  }

   
  ## create a new folder for results
  folder <- substr(date(),1,10)
  folder <- paste("Result",folder)
  folder <- paste(folder,floor(runif(1,1,100000)))
  dir.create(folder)
  
  write.table(Aest,file=paste(folder,'/Aest.txt',sep=''),col.names=FALSE,row.names=FALSE)
  write.table(Sest,file=paste(folder,'/Sest.txt',sep=''),col.names=FALSE,row.names=FALSE)

  result <- list(Aest,Sest)
  return(result)
  
  
  
}

gene_expression_input <-
function(X) {
  
  
  ## make sure the input is not empty
  if (is.null(X)) 
    stop(" Missing the mixture dataset")
  
  if (dim(X)[2]==1) 
    stop('ERROR: Please input more than one samples.')
   
  ## make sure the input is nonnegative.
  if (min(X)<0) {
    stop('ERROR: The value of gene expression should be positive.')
  }
  
  
  ## delete missing value
  if (nrow(X)!=nrow(na.omit(X))) {
    X <- na.omit(X)
    warning('There is missing value in the expression matrix.')
    warning('NA in X is removed.')
  }
  
  ## The correlation of two samples is 1.
  if ((ncol(X)==2)&&(corr(X)==1)) {
    stop('Correlation between the two samples is 1.')
  }

  return(X)
}

\name{mixing_matrix_computation}
\alias{mixing_matrix_computation}
\title{
Calculate and scale the mixing matrix
}
\description{
Calculate the mixing matrix based on the output from marker_gene_selection(), and scale the mixing matrix to make the sum of proportions from tumor and stroma equal to 1. The pure expression levels of tumor and stroma are also computed. 
}
\usage{
mixing_matrix_computation(X, a1, a2, dimenMatrix)
}
\arguments{
  \item{X}{
Gene expression data matrix
}
  \item{a1}{
The slope of marker genes in source 1
}
  \item{a2}{
The slope of marker genes in source 2
}
  \item{dimenMatrix}{
The dimention reduction matrix used to recover mixing matrix for all the samples
}
}
\value{
\item{Aest}{estimated mixing matrix}
\item{Sest}{estimated pure gene expression of two sources}
}
\author{
Niya Wang (wangny@vt.edu)
}
\examples{
a1<- matrix(runif(2),2,1)
a2<- matrix(runif(2),2,1)
X <- 1000*matrix(runif(20000),10000,2)
dimenMatrix <- NULL
Deconv <- mixing_matrix_computation(X, a1, a2, dimenMatrix)
}

\name{PureMCF7HS27}
\alias{PureMCF7HS27}
\docType{data}
\title{
pure MCF7 and HS27
}
\description{
pure MCF7 and HS27 expression data
}
\usage{data(PureMCF7HS27)}
\format{
  The format is:
Formal class 'ExpressionSet' [package "Biobase"] with 7 slots
  ..@ experimentData   :Formal class 'MIAME' [package "Biobase"] with 13 slots
  .. .. ..@ name             : chr ""
  .. .. ..@ lab              : chr ""
  .. .. ..@ contact          : chr ""
  .. .. ..@ title            : chr ""
  .. .. ..@ abstract         : chr ""
  .. .. ..@ url              : chr ""
  .. .. ..@ pubMedIds        : chr ""
  .. .. ..@ samples          : list()
  .. .. ..@ hybridizations   : list()
  .. .. ..@ normControls     : list()
  .. .. ..@ preprocessing    : list()
  .. .. ..@ other            : list()
  .. .. ..@ .__classVersion__:Formal class 'Versions' [package "Biobase"] with 1 slots
  .. .. .. .. ..@ .Data:List of 2
  .. .. .. .. .. ..$ : int [1:3] 1 0 0
  .. .. .. .. .. ..$ : int [1:3] 1 1 0
  ..@ assayData        :<environment: 0x000000000e979d20> 
  ..@ phenoData        :Formal class 'AnnotatedDataFrame' [package "Biobase"] with 4 slots
  .. .. ..@ varMetadata      :'data.frame':	0 obs. of  1 variable:
  .. .. .. ..$ labelDescription: chr(0) 
  .. .. ..@ data             :'data.frame':	2 obs. of  0 variables
  .. .. ..@ dimLabels        : chr [1:2] "sampleNames" "sampleColumns"
  .. .. ..@ .__classVersion__:Formal class 'Versions' [package "Biobase"] with 1 slots
  .. .. .. .. ..@ .Data:List of 1
  .. .. .. .. .. ..$ : int [1:3] 1 1 0
  ..@ featureData      :Formal class 'AnnotatedDataFrame' [package "Biobase"] with 4 slots
  .. .. ..@ varMetadata      :'data.frame':	0 obs. of  1 variable:
  .. .. .. ..$ labelDescription: chr(0) 
  .. .. ..@ data             :'data.frame':	22215 obs. of  0 variables
  .. .. ..@ dimLabels        : chr [1:2] "featureNames" "featureColumns"
  .. .. ..@ .__classVersion__:Formal class 'Versions' [package "Biobase"] with 1 slots
  .. .. .. .. ..@ .Data:List of 1
  .. .. .. .. .. ..$ : int [1:3] 1 1 0
  ..@ annotation       : chr "HG-U133A"
  ..@ protocolData     :Formal class 'AnnotatedDataFrame' [package "Biobase"] with 4 slots
  .. .. ..@ varMetadata      :'data.frame':	0 obs. of  1 variable:
  .. .. .. ..$ labelDescription: chr(0) 
  .. .. ..@ data             :'data.frame':	2 obs. of  0 variables
  .. .. ..@ dimLabels        : chr [1:2] "sampleNames" "sampleColumns"
  .. .. ..@ .__classVersion__:Formal class 'Versions' [package "Biobase"] with 1 slots
  .. .. .. .. ..@ .Data:List of 1
  .. .. .. .. .. ..$ : int [1:3] 1 1 0
  ..@ .__classVersion__:Formal class 'Versions' [package "Biobase"] with 1 slots
  .. .. ..@ .Data:List of 4
  .. .. .. ..$ : int [1:3] 3 1 0
  .. .. .. ..$ : int [1:3] 2 23 6
  .. .. .. ..$ : int [1:3] 1 3 0
  .. .. .. ..$ : int [1:3] 1 0 0
}

\examples{
data(PureMCF7HS27)
str(PureMCF7HS27)
}
\keyword{datasets}

\name{gene_expression_input}
\alias{gene_expression_input}
\title{
 Detect whether the input gene expression data are valid
}
\description{
Check the input gene expression data to see whether they are nonempty, nonnegative, etc.
}
\usage{
gene_expression_input(X)
}
\arguments{
  \item{X}{
gene expression data matrix with row representing genes/probe sets, and column representing samples.
}
}

\value{
If the input is valid, the output will be the same as the input; otherwise,
if the input contains NA, the corresponding rows will be deleted. if the input
contains negative value, the algorithm will stop and give error information.
}
\author{
 Niya Wang (wangny@vt.edu)
}

\examples{
gene_expression <- matrix(runif(2000),1000,2)
valid_gene_expression <- gene_expression_input(gene_expression)
}

\name{two_source_deconv}
\alias{two_source_deconv}
\title{
Main function to call other subfunction to deconvolute the mixed expression data.
}
\description{
This is the main function that is to call all the other subfunctions and realize the deconvolution of mixed expression data. When the real mixing matrix exist, it will also compare the estimated mixing matrix and real mixing matrix and give the E1 measurement.
}
\usage{
two_source_deconv(ExpressionData, lowper = 0.4, highper = 0.1, epsilon1 = 0.01, epsilon2 = 0.01, A = NULL, S1=NULL, S2=NULL, return = 0)
}
\arguments{
  \item{ExpressionData}{
gene expression data matrix/ExpressionSet object
}
  \item{lowper}{
The percentage of genes the user wants to remove with lowest norm. The range should be between 0 and 1.
}
  \item{highper}{
The percentage of genes the user wants to remove with highest norm.The range should be between 0 and 1.
}
  \item{epsilon1}{
Influence the number of marker genes. With increasing of epsilon1, the number marker genes in source 1 will increase. The value should be positive.
}
  \item{epsilon2}{
Influence the number of marker genes. With increasing of epsilon1, the number marker genes in source 2 will increase. The value should be positive.
}
  \item{A}{
real mixing matrix if existing
}
  \item{S1}{
Pure expression profile of first source if existing
}
  \item{S2}{
Pure expression profile of second source if existing
}
  \item{return}{
if it is equal to 0, do not return estimated S; otherwise, return the estimated S.
}
}

\value{
\item{Aest}{estimated mixing matrix}
\item{E1}{E1 measurement between real and estimated mixing matrix}
}
\author{
Niya Wang (wangny@vt.edu)
}
\examples{

data(NumericalMixMCF7HS27)
X <- NumericalMixMCF7HS27
deconvResult <- two_source_deconv(X, lowper = 0.4, highper = 0.1, epsilon1 = 0.1, epsilon2 = 0.1, A = NULL, S1=NULL,S2=NULL, return = 0)

}

\name{calc_E1}
\alias{calc_E1}
\title{
    function calculating the E1 measurement
}
\description{
   A function used to calculate the E1 measurement when the real mixing matrix is provided

}
\usage{
calc_E1(A, Aest)
}
\arguments{
  \item{A}{real mixing matrix
}
  \item{Aest}{
estimated mixing matrix
}
}

\value{
E1 measurement (numeric)
}

\author{
Niya Wang <wangny@vt.edu>
}

\examples{
A <- matrix(runif(4),2,2)
Aest <- matrix(runif(4),2,2)
E1 <- calc_E1(A,Aest)  # to calculate the similarity of two randowm 2*2 matrix

}

\name{dimension_reduction}
\alias{dimension_reduction}
\title{
Dimension reduction function
}
\description{
When the number of input samples is larger than 2, this function is called to reduce the dimension to 2 by using PCA.
}
\usage{
dimension_reduction(X)
}
\arguments{
  \item{X}{
 gene expression data matrix
}
}
\value{

\item{X}{}
\item{dimenMatrix}{the dimension reduction matrix used to recover the mixing matrix for all the samples}
}
\author{
Niya Wang (wangny@vt.edu)
}

\examples{
X <- matrix(runif(5000),1000,5)
dimenResult <- dimension_reduction(X)
}

\name{NumericalMixingMatrix}
\alias{NumericalMixingMatrix}
\docType{data}
\title{
mixing matrix of data NumericalMixMCF7HS27
}
\description{
real mixing matrix of data NumericalMixMCF7HS27
}
\usage{data(NumericalMixingMatrix)}
\format{
  The format is:
 num [1:2, 1:2] 0.775 0.15 0.225 0.85
 - attr(*, "dimnames")=List of 2
  ..$ : NULL
  ..$ : chr [1:2] "V1" "V2"
}

\examples{
data(NumericalMixingMatrix)
str(NumericalMixingMatrix) 
}
\keyword{datasets}

\name{UNDO-package}
\alias{UNDO-package}
\alias{UNDO}
\docType{package}
\title{
Implementation of UNDO (unsupervised deconvolution of tumor-stromal mixed expressions)
}
\description{
This package contains main function "two_source_deconv" to implement the deconvolution of mixed tumor-stromal expressions in a completely unsupervised way. The prior knowledge of mixing matrix or pure expression is not needed. The package detects marker genes and calculate the mixing matrix and pure expressions automatically.
}
\details{
\tabular{ll}{
Package: \tab UNDO\cr
Type: \tab Package\cr
Version: \tab 1.7.3\cr
Date: \tab 2014-04-30\cr
License: \tab GPL version 2 or later\cr
}
two_source_deconv(ExpressionData,lowper=0.4,highper=0.1,epsilon1=0.01,epsilon2=0.01,A=NULL,S1=NULL,S2=NULL,return=0)
}
\author{
Niya Wang <wangny@vt.edu>
}
\keyword{ package }
\keyword{methods}
\examples{
data(NumericalMixMCF7HS27)
X <- NumericalMixMCF7HS27
deconvResult <- two_source_deconv(X, lowper = 0.4, highper = 0.1, epsilon1 = 0.1, epsilon2 = 0.1, A = NULL, S1=NULL, S2=NULL, return = 0)
}

\name{marker_gene_selection}
\alias{marker_gene_selection}
\title{
Select marker genes in two sources
}
\description{
Select the marker genes in tumor and stroma in an unsupervised way
}
\usage{
marker_gene_selection(X, lowper, highper, epsilon1, epsilon2)
}
\arguments{
  \item{X}{
gene expression data
}
  \item{lowper}{
The percentage of genes the user wants to remove with lowest norm. The range should be between 0 and 1.
}
  \item{highper}{
The percentage of genes the user wants to remove with highest norm.The range should be between 0 and 1.
}
  \item{epsilon1}{
Influence the number of marker genes. With increasing of epsilon1, the number marker genes in source 1 will increase. The value should be positive.
}
  \item{epsilon2}{
Influence the number of marker genes. With increasing of epsilon1, the number marker genes in source 2 will increase. The value should be positive.
}
}

\value{

 \item{a1}{The slope of marker genes in source 1}
 \item{a2}{The slope of marker genes in source 2}
 \item{MG1}{The gene list of marker genes in source 1}
 \item{MG2}{The gene list of marker genes in source 2}
 \item{dimenMatrix}{dimension reduction matrix}

}
\author{
Niya Wang (wangny@vt.edu)
}
\examples{
X <- matrix(runif(20000),10000,2)
MG_set <- marker_gene_selection(X, 0.4, 0.1, 0.1, 0.1)
}
